﻿package
{
  
  //GAME CODE CLASS
  //beta 11 -- first release
  
 	/*
	IMPORTANT WARNING: DO *NOT* USE 'PUBLISH' OPERATION TO RE-GENERATE SWFs AFTER
	CODE CHANGES; TABLES INSERTED INTO FLASH-GENERATED HTML WILL BE LOST IF SO.
	INSTEAD, RE-GENERATE ONLY THE SWF -- LEAVE HTML PAGES ALONE.
	*/
  
  import flash.display.MovieClip;
  import flash.geom.Rectangle;
  import flash.events.*;
  import flash.media.Sound;
  import flash.net.*
  import flash.utils.Timer;
  import flash.text.*

  public class gameCodeClass extends MovieClip
  {
	  
	//DECLARE CONSTANTS & UTILITIES
	
	//"BASELS" IS COUNT OF PRE-BUILT ELEMENTS, USED TO MANAGE LATER SPAWNED ELEMENTS 
	//FRAME (1), BOTH PADDLES (2-3), SCOREBOARD (4), RSVPMETER (5), GREEN SCREEN (6)
	public var basEls = 6;
	
	public var numLevels = 8  //7 REGULAR PLUS ONE BONUS
	public var Ymax = 550;
	public var Xmax = 750;
	public var gameState = "play";
	public var randStore = new Array(0,0,0);
	public var thisRand = 0;
	public var lastRand = 0;
	public var rsvpRun = true;
	public var rsvpInterval = 0;
	public var playerWins = false;
	public var overTime;
	public var numScanlines;
	public var scoreLock = false;
	
	//GENERAL-PURPOSE LOOP INDEX VARIABLE
	public var i=0;
	
	//GENERAL-PURPOSE OBJECT REFERENCE ("WHICHELEMENT")
	public var we;
	
	//RANDOM-NUMBER VARIABLE
	public var r=0;
	
	//DEFAULTWORDS ARRAY FOR RSVP TARGETS WHILE IN LOAD STATE
	public var defaultWords = new Array("so","play","work","and","go","run","start","now","one","zero");
	
	//DECLARE LEVEL VARIABLES AND ARRAYS (NECESSARY TO MAKE THEM PUBLIC)
	public var currLevel;
	public var numTargets;
	public var paddleHeight;
	public var minSpeed;
	public var bonusSpeed;
	public var addSpeed;
	public var playerScore;
	public var enemyScore;
	public var strobe;
	public var crazyIvan;
	public var allRSVPTexts;
		
	//DECLARE ARRAYS FOR X AND Y SPEED, DIRECTION (AS ABOVE)
	public var XspeedArray;
	public var YspeedArray;
	public var XdirArray;
	public var YdirArray;
	public var scanSpeedArray;
	
	public var allRSVPBuffers = new Array(10);
	
	public var gameSound:Sound;
	public var theReq:URLRequest;
	
// *************
//  CONSTRUCTOR
// *************

	public function gameCodeClass():void
    {
		//READ IN LEVEL VARIABLES
		currLevel = MovieClip(root).levelObj.setLevel;
		numTargets = MovieClip(root).levelObj.setNumTargets;
		paddleHeight = MovieClip(root).levelObj.setPaddleHeight;
		minSpeed = MovieClip(root).levelObj.setMinSpeed;
		bonusSpeed = MovieClip(root).levelObj.setBonusSpeed;
		addSpeed = MovieClip(root).levelObj.setAddSpeed;
		playerScore = MovieClip(root).levelObj.setPlayerScore;
		enemyScore = MovieClip(root).levelObj.setEnemyScore;
		strobe = MovieClip(root).levelObj.setStrobe;
		crazyIvan = MovieClip(root).levelObj.setCrazyIvan;
		allRSVPTexts = MovieClip(root).levelObj.setRSVPTexts;
		
		//SET UP ARRAYS
		XspeedArray = new Array(basEls+numTargets);
		YspeedArray = new Array(basEls+numTargets);
		XdirArray = new Array(basEls+numTargets);
		YdirArray = new Array(basEls+numTargets);
		scanSpeedArray = new Array(basEls+numTargets+currLevel+1);
		
		//SPECIAL SOUND FOR BONUS LEVEL
		if(currLevel == 7) sounder("bonusLevelEngaged");
		
		//SET SIZE OF PADDLES
		MovieClip(root).playerPaddle.height = paddleHeight;
		MovieClip(root).enemyPaddle.height = paddleHeight;
		
		//SET UP CONTROL OF PLAYER PADDLE
		MovieClip(root).playerPaddle.startDrag(true, new Rectangle(0, paddleHeight/2, 0, Ymax - paddleHeight));
		
		//HIDE RSVPMETER
		MovieClip(root).rsvpMeter.visible = false;
		
		//COMPUTE LONG-WORD BUFFERS FOR RSVP FUNCTION
		//PREVENTS RSVP ITEMS FROM OVERRUNNING RIGHT EDGE
		for(i=0; i<10; i++)
		{
			var checkArray = allRSVPTexts[i].split(" ");
			//FIND LONGEST WORD
			var longIndex = 0;
			for(var j=0; j<checkArray.length; j++)
			{
				if(checkArray[j].length > checkArray[longIndex].length) longIndex = j;	
			}
			
			//COMPUTE RSVP NO-DISPLAY BUFFER BY ASSIGNING LONGEST WORD TO INVISIBLE ELEMENT
			MovieClip(root).rsvpMeter.tf.text = checkArray[longIndex];
			allRSVPBuffers[i] = MovieClip(root).rsvpMeter.tf.textWidth;
		}
		
		//SPAWN SCANLINES -- SPAWN *BEFORE* TARGETS, TO ALLOW ADDITIONAL TARGETS IN BONUS LEVEL
		numScanlines = currLevel+1;
		for(i=basEls; i<basEls+numScanlines; i++)
		{
			we = new scanlineClass();
			we.x = 375;
			we.y = 0 - Math.random()*200;
			we.visible = false;
			we.name="scanline";
			scanSpeedArray[i] = 2 + Math.random()*6;
			MovieClip(root).addChild(we);
		}
		
		//SPAWN TARGET ELEMENTS: "BASELS" SKIPS OVER PRE-BUILT ELEMENTS
		for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
		{
			spawnTarget(i);
		}
		
		//START GAME ANIMATION
		addEventListener(Event.ENTER_FRAME, animate);
		
		//HIDE GREEN SCREEN ('FIELD' STROBE EFFECT)
		MovieClip(root).greenScreen.visible = false;
		
	}

// ***************
//  CUSTOM METHODS
// ***************
	
	//SPAWN A TARGET ELEMENT
	public function spawnTarget(whichTarget): void
	{
		var nt = new targetClass();
		nt.name = "target";
		MovieClip(root).addChild(nt);
		initTarget(whichTarget);
		wallBounce(whichTarget);
		getRSVP(whichTarget);
	}
	
	//SET FEATURES OF TARGETS INITIALLY AND WHEN RE-SETTING
	public function initTarget(whichTarget): void
	{
		//DESIGNATE THE PAGE ELEMENT IN QUESTION
		we = MovieClip(root).getChildAt(whichTarget);
		
		sounder("enemySound");
		
		//SET START POSITION
		we.x = Xmax - we.tf.textWidth;
		we.y = we.height + Math.random()*(Ymax - we.height*2) ;

		//SET ENEMY PADDLE ON TARGET
		MovieClip(root).enemyPaddle.y = we.y;
		
		//ASSIGN DEFAULT TEXT TO START
		we.tf.text = defaultWords[freshRand(defaultWords.length, 0)];
		
		//RANDOMLY CHOOSE INITIAL DIRECTIONS OF MOVEMENT
		if(freshRand(2, 2) == 0)
		{
			YdirArray[whichTarget] = "up";			
		}
		else
		{
			YdirArray[whichTarget] = "down";
		}
		
		XdirArray[whichTarget] = "left";
	}
	
	//RESET SLOPE OF TRAVEL (XSPEED, YSPEED) ON WALL COLLISION
	function wallBounce(whichTarget): void
	{
		sounder("enemySound");
		
		scoreLock = false;
		
		XspeedArray[whichTarget] = minSpeed + Math.floor(Math.random()*bonusSpeed);
		YspeedArray[whichTarget] = minSpeed + Math.floor(Math.random()*bonusSpeed);		
	}

	
	//ANIMATE WORD ELEMENT (TARGET, OR BALL): CALLBACK TO ENTER-FRAME
	//THIS IS THE MAIN GAME LOGIC
	public function animate(event:Event): void
	{	
		if(gameState == "play")
		{
			//FIRST THE MAIN BUSINESS...
			
			for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
			{
				we = MovieClip(root).getChildAt(i);
				//IMPLEMENT CRAZY-IVAN STUNT IF ENABLED
				if(crazyIvan == true)
				{
					if(Math.random()*150<1)
					{
						if(XspeedArray[i] == 0)
						{
							XspeedArray[i] = 8;
							YspeedArray[i] = 0;
							XdirArray[i] = "left";
						}
						else
						{
							XspeedArray[i] = 0;
						}
					}
				}
				
				//Y AXIS
				if(YdirArray[i] == "up")
				{
					we.y -= YspeedArray[i];	
				}
				else //DIRECTION IS DOWN
				{
					we.y += YspeedArray[i];					
				}
				
				//X AXIS
				if(XdirArray[i] == "left")
				{
					we.x -= XspeedArray[i];	
				}
				else //DIRECTION IS RIGHT
				{
					we.x += XspeedArray[i];					
				}			
				
				//BOUNDARY TESTS
				//TOP
				if(we.y < YspeedArray[i]) 
				{
					YdirArray[i] = "down";
					wallBounce(i);
				}
				//BOTTOM
				if(we.y > (Ymax - we.height/2 - YspeedArray[i]))
				{
					YdirArray[i] = "up";
					wallBounce(i);
				}
				
				//SPECIAL LEFT-SIDE TEST FOR FALSE TARGETS 
				//AFTER FIRST TWO, EVERY EVEN-NUMBERED TARGET IS FALSE (EXTRA FUN FOR BONUS LEVEL)
				//FALSE TARGETS RESET 100 PX BEFORE REACHING LEFT WALL
				if(i > basEls+numScanlines+1 && i%2 == 0 && we.x < 100)
				{
					initTarget(i);
					wallBounce(i);
				}				
				
				//LEFT -- PADDLE COLLISION OR MISS
				if(we.x < 10 + we.tf.textWidth/2 - XspeedArray[i])
				{
					if(we.hitTestObject(MovieClip(root).playerPaddle))  // COLLISION: PLAYER SCORES
					{
						XdirArray[i] = "right";
						sounder("backSound");
						if(scoreLock == false)
						{
							playerScore ++;
							enemyScore --;
						}
						//scoreLock = true;
						we.x = we.width/2;
						wallBounce(i);
						
						//IN BONUS LEVEL, SPAWN AN ADDITIONAL TARGET
						if(currLevel == numLevels-1)
						{
							numTargets ++;
							spawnTarget(basEls+numScanlines+numTargets-1);

						}
						
						//IF ADDSPEED IS ENABLED, ACCELERATE TARGETS
						if(addSpeed && (minSpeed < 3.5))
						{
							minSpeed *= 1.25;
						}
					}
					else  // MISS
					{
						sounder("missSound");
						
						playerScore --;
						enemyScore ++;
						initTarget(i);
						wallBounce(i);
					}
				}
				
				//RIGHT
				if(we.x > Xmax - we.tf.textWidth/2 - XspeedArray[i])
				{
					XdirArray[i] = "left";
					wallBounce(i);
				}					
					
			} //END FOR LOOP
		
		} 
		else //GAMESTATE IS 'OVER'
		{
			removeEventListener(Event.ENTER_FRAME, animate);
			
			//SHOW ANY HIDDEN ELEMENTS
			MovieClip(root).levelObj.visible = true;
			MovieClip(root).playerPaddle.visible = true;
			MovieClip(root).enemyPaddle.visible = true;
			MovieClip(root).scoreboard.visible = true;
			
			//HIDE GREEN SCREEN
			MovieClip(root).greenScreen.visible = false;
			
			//FREEZE AND PARK THE PADDLES
			MovieClip(root).playerPaddle.stopDrag();
			MovieClip(root).playerPaddle.y = Ymax/2;
			MovieClip(root).enemyPaddle.y = Ymax/2;
			
		
			//HIDE TARGET ELEMENTS, PARK SCANLINES
			for(i=0; i<MovieClip(root).numChildren; i++)
			{
				we = MovieClip(root).getChildAt(i);
				if(we.name == "target") we.visible = false;
				if(we.name == "scanline") we.y = -200;
			}
			
			//OUTCOME MESSAGE
			if(playerWins)
			{
				sounder("winSound");
				MovieClip(root).scoreboard.tf.text = "PASS";
			}
			else
			{
				sounder("loseSound");
				MovieClip(root).scoreboard.tf.text = "FAIL";
			}
			
			overTime = new Timer(5000,1);
			overTime.addEventListener(TimerEvent.TIMER_COMPLETE, overThis);
      		overTime.start();
		}
		
	//AND SOME OTHER BUSINESS...
			
			//RUN RSVP EFFECT
			rsvpInterval ++;
			if(rsvpInterval == 45)
			{
				rsvpInterval = 0;
				serialize();
			}
			
			//UPDATE SCOREBOARD
			if(gameState == "play") MovieClip(root).scoreboard.tf.text = playerScore + "|" + enemyScore;
			if(enemyScore <= 0)
			{
				gameState = "over";
				playerWins = true;
			}
			if(playerScore <= 0)
			{
				gameState = "over";
				playerWins = false;
			}
			
			//SCANLINE EFFECT
			for(i=basEls; i<basEls+numScanlines; i++)
			{
				we = MovieClip(root).getChildAt(i);
				if(we.y > 0) we.visible = true;
				//VARY SIZE OF SCANLINE
				we.height = 1 + Math.floor(Math.random()*8);
				//MOVE DOWN-SCREEN
				we.y += scanSpeedArray[i];
				//SET ALPHA
				we.alpha = (Math.random()*4)/10;
				if(we.y > Ymax)
				{
					we.y = 0 - 100 - Math.random()*200;
					we.visible = false;
					scanSpeedArray[i] = 1 + Math.random()*4;
				}
			}
			
			//DO STROBE EFFECTS IF ENGAGED
			if(strobe != "none" && Math.random()*27 < 1) strobeEffects();
			
			//ANIMATE ENEMY PADDLE
			var proxIndex = basEls;
			for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
			{
				if(MovieClip(root).getChildAt(i).x > MovieClip(root).getChildAt(proxIndex).x)
				{
					proxIndex = i;
				}
			}
			var ep = MovieClip(root).enemyPaddle;
			var proxie = MovieClip(root).getChildAt(proxIndex);
			//KEEP ENEMY PADDLE FROM TRACKING OUT OF GAME BOX
			if(proxie.y < (Ymax - paddleHeight/2) && proxie.y > paddleHeight/2)
			{
				ep.y = proxie.y;
			}
	
	} //END ANIMATE() FUNCTION
	
	//GAME-OVER BUSINESS
	public function overThis(event:TimerEvent):void
	{
		overTime.stop();
		if(playerWins)
		{
			if(currLevel == numLevels - 1)  //REWARD FOR BONUS LEVEL
			{
				navigateToURL(new URLRequest("../ifftwn.htm"), "_self");
			}
			else
			{
				var levelName = "";
				switch(currLevel)  //ADVANCE TO NEXT REGULAR-LEVEL TEXT
				{
					case 0:
						levelName = "abergorlech";
						break;						
					case 1:
						levelName = "bronwydd";
						break;						
					case 2:
						levelName = "cefneithin";
						break;						
					case 3:
						levelName = "dryslwin";
						break;					
					case 4:
						levelName = "fflint";
						break;						
					case 5:
						levelName = "gwynedd";
						break;						
					case 6:
						levelName = "hirwaun";
						break;
							
				}
				navigateToURL(new URLRequest(levelName + ".html"), "_self");
			}
		}
		else  //REPEAT LEVEL
		{
			//BONUS LEVEL ONLY: RESET NUMTARGETS AND CLEAN UP
			if(currLevel == numLevels-1)
			{
				//REMOVE ALL TARGETS
				//MUST *RUN THIS LOOP BACKWARDS*, SINCE NUMCHILDREN CHANGES
				//EVERY TIME A TARGET IS REMOVED!
				for(i=MovieClip(root).numChildren-1; i>-1; i--)
				{
					if(MovieClip(root).getChildAt(i).name == "target")
					{
						MovieClip(root).removeChildAt(i);
					}
				}
				//RESET NUMTARGETS
				numTargets = MovieClip(root).levelObj.setNumTargets;
				//RESPAWN TARGETS
				for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
				{
					spawnTarget(i);
					initTarget(i);
					wallBounce(i);
				}
				MovieClip(root).rsvpMeter.visible = false;
			}
			
			//RESET SCORE
			playerScore = MovieClip(root).levelObj.setPlayerScore;
			
			//RESET SPEEDS TO START LEVELS
			for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
			{
				XspeedArray[i] = minSpeed + Math.random()*bonusSpeed;
				YspeedArray[i] = minSpeed + Math.random()*bonusSpeed;
			}

			//UN-HIDE TARGETS
			for(i=0; i<MovieClip(root).numChildren; i++)
			{
				we = MovieClip(root).getChildAt(i);
				if(we.name == "target") we.visible = true;
			}
			//RE-ACTIVATE PLAYER PADDLE
			MovieClip(root).playerPaddle.startDrag(true, new Rectangle(0, paddleHeight/2, 0, Ymax - paddleHeight));
			addEventListener(Event.ENTER_FRAME, animate);
			enemyScore = 10 - playerScore;
			gameState = "play";
		}
	}
	
// **** RSVP METHODS ****
	
	// SELECT TEXT FOR RSVP
	function getRSVP(whichTarget)
	{
		
		//DESIGNATE THE TARGET IN QUESTION
		we = MovieClip(root).getChildAt(whichTarget);
		
		//GET ITEM NUMBER FOR ARRAY SELECTION, USING GENERAL RANDOM-NUMBER UTILITY
		//RSVP IS CLIENT '1'
		r = freshRand(10,1);
		
		//SELECT AND SPLIT INTO ARRAY OF WORDS
		we.rsvpTextArray = allRSVPTexts[r].split(" ");
		//RETRIEVE RIGHTHAND BUFFER VALUE
		we.currRSVPBuffer = allRSVPBuffers[r];
		
	}
	
	//CYCLE THROUGH RSVP TEXT -- CALLED FROM ANIMATE()
	function serialize()
	{
		for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
		{
			//SPECIFY TARGET OBJECT FOR THIS PASS
			we = MovieClip(root).getChildAt(i);
			var theText = "";
			
			//NO CHANGES IF WITHIN LONG-WORD BUFFER AT EITHER EDGE OF SCREEN
			if((we.x < Xmax - we.currRSVPBuffer && we.x > we.currRSVPBuffer) && rsvpRun)
			{
				if(we.rsvpTextArray[we.rsvpCount] == undefined) //TEXT IS LOADING
				{
					theText = defaultWords[freshRand(10, 1)]; //SUBSTITUTE DEFAULT WORD
				}
				else  //TEXT ALL LOADED
				{
					theText = we.rsvpTextArray[we.rsvpCount];
				}
				
				//WRITE RESULTS TO SCREEN
				we.tf.text = theText;

				//GET NEW TEXT IF WE'RE DONE WITH THIS ONE
				if(we.rsvpCount == we.rsvpTextArray.length)
				{
					getRSVP(i);
					we.rsvpCount = -1;
				}
				we.rsvpCount ++;
			}
		}
	}  // END SERIALIZE()
	
	function strobeEffects()
	{
		switch(strobe)
		{
			case "field":
				if(MovieClip(root).greenScreen.visible)
				{
					MovieClip(root).greenScreen.visible = false;
				}
				else
				{
					MovieClip(root).greenScreen.visible = true;
				}
				break;
					
			case "paddles":
				if(MovieClip(root).playerPaddle.visible)
				{
					MovieClip(root).playerPaddle.visible = false;
					MovieClip(root).enemyPaddle.visible = false;
				}
				else
				{
					MovieClip(root).playerPaddle.visible = true;
					MovieClip(root).enemyPaddle.visible = true;
				}
				break;

			case "game":
				if(MovieClip(root).playerPaddle.visible)
				{
					MovieClip(root).playerPaddle.visible = false;
					MovieClip(root).enemyPaddle.visible = false;
					MovieClip(root).levelObj.visible = false;
					MovieClip(root).scoreboard.visible = false;
					
					for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
					{
						MovieClip(root).getChildAt(i).visible = false;
					}
				}
				else
				{
					MovieClip(root).playerPaddle.visible = true;
					MovieClip(root).enemyPaddle.visible = true;
					MovieClip(root).levelObj.visible = true;
					MovieClip(root).scoreboard.visible = true;
					
					for(i=basEls+numScanlines; i<basEls+numScanlines+numTargets; i++)
					{
						MovieClip(root).getChildAt(i).visible = true;
					}
				}
				break;
		}	
	}

	
	//SOUND HANDLER
	public function sounder(whichSound): void
	{
		theReq = new URLRequest("../sounds/mp3/game/" + whichSound + ".mp3");
		gameSound = new Sound();
  		gameSound.load(theReq);
		gameSound.play();
	}
	
	//TWO-PASS UNIQUE RANDOM NUMBER GENERATOR
	//MODIFIED TO SUPPORT CALLS FROM MULTIPLE FUNCTIONS
	//CLIENT CODES:
	//0 FOR DEFAULT WORD
	//1 FOR RSVP TEXT
	//2 FOR BINARY COIN FLIP (UP/DOWN DIRECTIONS)
	public function freshRand(range, client): int
	{
		lastRand = randStore[client];
		while(thisRand == lastRand)
		{
			thisRand = Math.floor(Math.random()*range);	
		}
		randStore[client] = thisRand;
		return thisRand;
	}
	
		/*
		IMPORTANT WARNING: DO *NOT* USE 'PUBLISH' OPERATION TO RE-GENERATE SWFs AFTER
		CODE CHANGES; TABLES INSERTED INTO FLASH-GENERATED HTML WILL BE LOST IF SO.
		INSTEAD, RE-GENERATE ONLY THE SWF -- LEAVE HTML PAGES ALONE.
		*/
	

  }  //END CLASS
} //END PACKAGE
