﻿package
{
  //TEXTCODE CLASS
  //beta 11 -- first release
  
	/*
	IMPORTANT WARNING: DO *NOT* USE 'PUBLISH' OPERATION TO RE-GENERATE SWFs AFTER
	CODE CHANGES; TABLES INSERTED INTO FLASH-GENERATED HTML WILL BE LOST IF SO.
	INSTEAD, RE-GENERATE ONLY THE SWF -- LEAVE HTML PAGES ALONE.
	*/
  
// NOTE:
// IN XML SOURCEFILES, $ BEGINS ITALICS, % FINISHES, ~ INDICATES <BR>, ^ IS ACUTE ACCENT E;
//  { STARTS SPECIAL-SOUND CODE AND } TERMINATES; ] IS ALIAS FOR SECRET LINK; 
  
  import flash.display.MovieClip;
  import flash.events.*;
  import flash.media.*;
  import flash.utils.Timer;
  import flash.net.*;
  import flash.text.*;

  public class textCodeClass extends MovieClip
  {  
	//DECLARE CONSTANTS & UTILITIES
	public var currLevel;
	public var numNodes;
	public var charCount = 0;
	public var Xmax = 750;
	public var Ymax = 550;
	public var i:int = 0;
	public var tempText = "";
	public var inProgress = true;
	public var transSound:Sound;
	public var transSoundChannel:SoundChannel;
	public var transSoundTransform:SoundTransform;
	public var specialSound:Sound;
	public var bgSound:Sound;
	public var bgSoundChannel:SoundChannel;
	public var bgSoundTransform:SoundTransform;
	public var sndReq:URLRequest;
	public var textReq:URLRequest;
	public var textLoader:URLLoader;
	public var theText:String = "";
	public var theNodes = new Array();
	public var streamInt:Timer;
	public var pauseTime:Timer;
	public var overTime:Timer;
	public var deformInt:Timer;
	public var noDeform:Array;
	public var itals:TextFormat;
	public var gotBonus = false;
	public var linkPoint;
	public var emphStartArray = new Array();
	public var emphEndArray = new Array();
	public var emphStart;
	public var emphEnd;
	
	//DECLARE NUMBER OF LEVELS - CONSTANT: 7 LEVELS PLUS BONUS
	public var numLevels = 8;

	//DECLARE NUMBER OF TRANSIENT SOUNDS FOR TEXT STREAMING PHASE
	public var numTextSounds = 100;

	//DECLARE NUMBER OF TRANSIENT SOUNDS FOR TEXT DEFORM PHASE
	public var numDeformSounds = 20;

	//SET THE STARTING NODE - CONSTANT
	public var currNode = 0;

	//SET INITIAL STATE: VALUES ARE 'STARTING' 'STREAMING', 'PAUSING', 'DEFORMING'
	public var theState = "starting";

	//FOR FANCY ITALICS HANDLING (CURSE YOU, INNERHTML!)
	public var bufferIt = false;
	public var specBuffer = "";

	//REVERSE LOCK (NO REVERSE FROM LEVEL-UP SCREEN)
	public var reverseLock = false;
	
// *************
//  CONSTRUCTOR
// *************

	public function textCodeClass():void
    {
		//READ IN LEVEL VARIABLE FROM CHILD OBJECT
		currLevel = MovieClip(root).textLevelObj.setLevel;

		//BLANK MESSAGE FIELD ("SCOREBOARD")
		MovieClip(root).scoreboard.tf.text = "";
		
		//SET TEXT FORMAT FOR ITALICS
		itals = new TextFormat();
		itals.italic = true;
		
		//HIDE SPECIAL HTML TEXT FIELD (FINAL NODE ONLY)
		MovieClip(root).htmlReadout.visible = false;
		
		//START XML LOADING
		textReq = new URLRequest("../texts/level_"+currLevel+".xml");
		textLoader = new URLLoader();
		textLoader.addEventListener(Event.COMPLETE, gotText);
		try
		{
			textLoader.load(textReq);
		}
		catch(error:Error)
		{
			trace("Unable to load URL: " + error);
		}
		
		//SET LISTENER FOR MOUSECLICKS
		addEventListener(MouseEvent.CLICK, clicker);
		
		//START BACKGROUND SOUND (HUM)
		sndReq = new URLRequest("../sounds/mp3/text/hum.mp3");
		bgSound = new Sound();
  		bgSound.load(sndReq);
		bgSoundTransform = new SoundTransform(0);  //SILENCE, PLEASE
		bgSoundChannel = bgSound.play(0, 0, bgSoundTransform);
		bgSoundChannel.addEventListener(Event.SOUND_COMPLETE, reSound);

	} //END CONSTRUCTOR
	
// ***************
//  CUSTOM METHODS
// ***************
	
	//TEXTUP(): READ ONE CHARACTER AT A TIME FROM XML INPUT
	public function textUp(event:TimerEvent): void
	{
		var theChar = theText.charAt(charCount);
		
		//INSERT BLANK LINE IN TITLE SCREEN
		if(charCount == 0 && currNode == 1) tempText = String.fromCharCode(10);
		
		switch(theChar)  //HANDLE SPECIAL CHARACTERS
		{
			case "@":  //&NBSP; IN JS VERSION
				tempText += " ";
				break;
			
			case "~":  //LINE BREAK (<BR> IN JS VERSION)
				tempText += String.fromCharCode(10);
				break;
	
			case "$":  //START EMPHASIS
				emphStartArray.push(MovieClip(root).readout.tf.text.length);
				break;
		
			case "%":  //END EMPHASIS
				emphEndArray.push(MovieClip(root).readout.tf.text.length);
				break;
				
			case "^":  //FRENCH ACCENTED E
				tempText += String.fromCharCode(233);
				break;
				
			case "{":  //BEGIN SPECIAL SOUND COMMAND
				specBuffer = "";
				bufferIt = true;
				break;
				
			case "}":  //END SPECIAL SOUND COMMAND
				bufferIt = false;
				switch(specBuffer)
				{
					case "0":
						specialSounder("thunderclap");
						break;
					case "1":
						specialSounder("rimshot");
						break;
					case "2":
						specialSounder("megavore");
						break;
					case "3":
						specialSounder("textSound_30");
						break;		
				}
				break;
				
			case "]":  //INSERT SECRET LINK TO BONUS LEVEL
				gotBonus = true;
				linkPoint = MovieClip(root).readout.tf.text.length;
				tempText += "secrets";
				break;
			
			default:
				if(bufferIt)
				{
					specBuffer += theChar;
				}
				else
				{
					//ADD THE CHARACTER
					tempText += theChar;
				}
				break;
		}
		
		//DUMP TEMPTEXT TO READOUT FIELD
		MovieClip(root).readout.tf.text = tempText;

		//HANDLE EMPHASIS
		for(i=0; i<emphStartArray.length; i++)
		{
			emphStart = emphStartArray[i];
			if(emphEndArray[i] == undefined || emphEndArray[i] > MovieClip(root).readout.tf.text.length)
			{
				emphEnd = MovieClip(root).readout.tf.text.length;
			}
			else
			{
				emphEnd = emphEndArray[i];
			}
			if(emphEnd > emphStart) MovieClip(root).readout.tf.setTextFormat(itals, emphStart, emphEnd);
		}
							
		//INCREMENT CHARACTER COUNT
		charCount++;
		
		//CHARACTER ENTRY SOUND EFFECTS
		if(currNode > 1 && Math.floor(Math.random()*75) == 1)  //TRANSIENT SOUND FOR REGULAR TEXT NODES
		{
			sounder("textSound_"+Math.floor(Math.random()*numTextSounds));
		}
		
		//PROGRESSIVE MUTING FOR BG SOUND: EXCLUDES TITLE NODES
		var theVol = 1;
		if(theText.length > 140)
		{
			var charsLeft = theText.length - charCount
				if(charsLeft < 141 && charsLeft > 120)
				{
					theVol = 0.875;
				}	
				if(charsLeft < 121 && charsLeft > 100)
				{	
					theVol = 0.75;
				}	
				if(charsLeft < 101 && charsLeft > 80)
				{
					theVol = 0.625;
				}	
				if(charsLeft < 81 && charsLeft > 60)
				{	
					theVol = 0.5;
				}	
				if(charsLeft < 61 && charsLeft > 40)
				{
					theVol = 0.375;
				}	
				if(charsLeft < 41 && charsLeft > 20)
				{
					theVol = 0.25;
				}	
				if(charsLeft < 21)
				{
					theVol = 0.125;
				}
			bgSoundTransform = new SoundTransform(theVol);
			bgSoundChannel.soundTransform = bgSoundTransform;
		}
		
		if(charCount == theText.length) //LAST CHARACTER HAS STREAMED IN
		{
			//SIGNAL END OF TEXT STREAM
			transSoundChannel.stop();
			sounder("endBeep");
			
			//SET BG SOUND VOL TO ZERO
			bgSoundTransform = new SoundTransform(0);
			bgSoundChannel.soundTransform = bgSoundTransform;

			clearStates();
			theState = "pausing";
			
			if(gotBonus)  //SPECIAL CASE FOR FINAL NODE OF FINAL LEVEL
			{
				
				//GET TEXT OUT OF READOUT (PLAIN-TEXT) FIELD
				var ft = MovieClip(root).readout.tf.text;
				//DELETE EXISTING STRING ('SECRETS') WHERE LINK CUE WILL GO
				var ftUp = ft.substring(0,linkPoint);
				var ftDown = ft.substring(linkPoint+8);
				//INSERT MODIFIED TEXT INTO HTMLREADOUT FIELD
				MovieClip(root).htmlReadout.tf.htmlText = ftUp + "<a href='level_7.html' target='_self'>secrets</a> " + ftDown;
				//HIDE READOUT FIELD, SHOW HTMLREADOUT
				MovieClip(root).readout.visible = false;
				MovieClip(root).htmlReadout.visible = true;
			}
			else  //FOR ALL OTHER NODES, WAIT THEN GO TO DEFORM PHASE
			{
				//CALCULATE WAIT TIME BEFORE DEFORMATION: 10 SECS + FACTOR BASED ON TEXT LENGTH
				var waitSpan = 10000 + (MovieClip(root).readout.tf.text.length * 3);
				pauseTime = new Timer(waitSpan,1);
				pauseTime.addEventListener(TimerEvent.TIMER_COMPLETE, waitABeat);
				pauseTime.start();
			}
		}
		
	}  // END OF TEXTUP() METHOD
	
	public function advance():void //MOVE TO NEXT NODE
	{
		clearStates();
		theState = "streaming";
		
		//PLAY BEEP
		sounder("beep");
		
		//TYPING SOUND FOR INITIAL (TITLE) NODE
		if(currNode == 0)
		{
			transSoundTransform = new SoundTransform(0);
			transSoundChannel.soundTransform = transSoundTransform;
			sounder("typing");
		}
		
		//ACTIVATE BG SOUND (HUM) IF NOT ON LEVEL-UP SCREEN
		if(currNode < numNodes)
		{
			bgSoundTransform = new SoundTransform(1);
			bgSoundChannel.soundTransform = bgSoundTransform;
		}
		
		//BLANK TEXT DISPLAY
		MovieClip(root).readout.tf.text = "";
		
		//HAVE WE SEEN ALL NODES?  IF SO, NEXT GAME LEVEL UNLESS AT END
		if(currNode == numNodes)
		{
			//TRIPLE BEEP
			sounder("tripleBeep");
			
			//INCREMENT LEVEL
			currLevel ++;
			
			//LOCK REVERSE FUNCTION
			reverseLock = true;
			
			//DISPLAY "LEVEL UP" OR "GAME OVER" MESSAGE
			if(currLevel < numLevels -1) //REGULAR LEVELS 0 THRU 6; 7 IS BONUS
			{
				MovieClip(root).scoreboard.tf.text = "LEVEL UP";
			}
			else if(currLevel == numLevels - 1)  //FINAL LEVEL
			{
				sounder("youWin");
				MovieClip(root).htmlReadout.visible = false;
				MovieClip(root).scoreboard.tf.text = "GAVE MORE";		
			}
			
			//SET TIMEOUT TO TRANSITION
			overTime = new Timer(5000,1);
			overTime.addEventListener(TimerEvent.TIMER_COMPLETE, overThis);
      		overTime.start();
		}
		else  //DISPLAY NEXT TEXT NODE
		{
			theText = theNodes[currNode];
			tempText = "";
			emphStartArray = new Array();
			emphEndArray = new Array();
			charCount = 0;
			streamInt = new Timer(35,0);
			streamInt.addEventListener(TimerEvent.TIMER, textUp);
			streamInt.start();
			currNode ++;
		}
		
	}  //END ADVANCE() FUNCTION
	
	//DEFORMATION FUNCTION
	public function textDeform(event:TimerEvent):void
	{
		//SOUND EFFECTS
		if(Math.random()*5 < 1)
		{
			sounder("ds_"+Math.floor(Math.random()*numDeformSounds));
		}
		
		var currText = MovieClip(root).readout.tf.text;
		
		//CAN'T INCLUDE LAST CHARACTER BECAUSE OF STRING-SPLITTING TECHNIQUE
		var rand = Math.floor(Math.random()*currText.length-1);
	
		
		//CHECK IF ALPHANUMERAL
		var q = currText.charCodeAt(rand);
		var alphanumeral = false;
		if((q > 47 && q < 58) || (q > 64 && q < 91) || (q> 96 && q < 123)) alphanumeral = true;
		
		//REPLACE IF OKAY
		if(alphanumeral)
		{
			//GENERATE REPLACEMENT CHARACTER
			var antiChar;
			switch(Math.floor(Math.random()*3))
			{
				case 0:
					antiChar = Math.floor(Math.random()*10);
					break;
					
				case 1:
					antiChar = String.fromCharCode(97 + Math.floor(Math.random()*26));
					break;
					
				case 2:
					antiChar = Math.floor(Math.random()*2);
					break;
			}
			
			var upString = currText.substring(0, rand);
			var downString = currText.substring(rand+1, currText.length);
			currText = upString + antiChar + downString;	
		}
		
		MovieClip(root).readout.tf.text = currText;
			
	}  //END TEXTDEFORM()
	
	public function waitABeat(event:TimerEvent):void
	{
		clearStates();
		theState = "deforming";
	
		//START DEFORMATION AS INTERVAL
		deformInt = new Timer(350,0);
		deformInt.addEventListener(TimerEvent.TIMER, textDeform);
		deformInt.start();
		
	}//END WAITABEAT()
	
	//FINAL TRANSITION
	public function overThis(event:TimerEvent):void
	{
		overTime.removeEventListener(TimerEvent.TIMER_COMPLETE, overThis);
		
		//NOTE: FILES IN FLASH SET USE .HTML, WHILE FILES IN AJAX SET USE .HTM
		//THIS IS DELIBERATE
		if(currLevel < numLevels-1)  //NOT AT LAST LEVEL YET
		{
			navigateToURL(new URLRequest("level_"+currLevel+".html"), "_self");
		}
		else  //END OF SHOW, BONUS LEVEL NOT ENGAGED
		{
			//BACK TO START PAGE, OUTSIDE FLASH DIRECTORY
			navigateToURL(new URLRequest("../index.htm"), "_self");
		}

	}
	
	public function clearStates():void
	{
		if(theState == "streaming")
		{
			if(streamInt) streamInt.removeEventListener(TimerEvent.TIMER, textUp);
		}
		if(theState == "deforming")
		{
			if(deformInt) deformInt.removeEventListener(TimerEvent.TIMER, textDeform);
		}
		if(theState == "pausing")
		{
			if(pauseTime) pauseTime.stop();
		}
	}
	
	//TRANSIENT SOUND HANDLER
	public function sounder(whichSound):void
	{
		sndReq = new URLRequest("../sounds/mp3/text/"+whichSound+".mp3");
		transSound = new Sound();
		transSound.load(sndReq);
		transSoundTransform = new SoundTransform(0.25);
		transSoundChannel = transSound.play(0, 0, transSoundTransform);
	}
	
	//SPECIAL SOUND HANDLER
	public function specialSounder(whichSound):void
	{
		sndReq = new URLRequest("../sounds/mp3/text/"+whichSound+".mp3");
		specialSound = new Sound();
		specialSound.load(sndReq);
		specialSound.play();
	}

	//MOUSECLICK HANDLER
	public function clicker(event:MouseEvent):void
	{
		inProgress = false;
		//STOP STREAMING OR DEFORM IF NECESSARY; MARK AS IN-PROGRESS OR NOT
		
		if(theState == "streaming") // TEXT STREAMING IN; STOP STREAMING AND MARK AS IN-PROGRESS
		{
			streamInt.reset();
			inProgress = true;
		}
		
		if(theState == "pausing")
		{
			if(pauseTime) pauseTime.reset();	
		}
		
		if(theState == "deforming")  // IN DEFORM PHASE; STOP DEFORM PROCESS AND MARK NOT IN-PROGRESS
		{
			deformInt.reset();
			inProgress = false;	
		}
		
		if(mouseX > Xmax/2)  //CLICK ON RIGHT - ADVANCE
		{
			advance();
		}
		else  //CLICK ON LEFT - REPEAT
		{
			if(!reverseLock)
			{
				if(inProgress && currNode > 1)  // STEP BACK TWO IF CLICK WAS IN-PROGRESS 
				{
					currNode -=2;
				}
				else if(currNode > 0)  // STEP BACK ONE IF NOT IN-PROGRESS
				{
					currNode --;	
				}
				advance();
			}
		}

	}

	//KEEP THE BG SOUND CYCLING
	public function reSound(event:Event):void
	{
		bgSoundChannel = bgSound.play(0, 0, bgSoundTransform);
		bgSoundChannel.addEventListener(Event.SOUND_COMPLETE, reSound);
	}
	
	
	//CALLBACK TO XML LOADER: PUSHES TEXTS INTO NODES ARRAY
	public function gotText(event:Event):void
	{
		var theXML:XML = new XML(textLoader.data);
		numNodes = theXML.node.length();
		for(i=0; i<numNodes; i++)
		{
			var z = theXML.node[i].toString();
			theNodes.push(z);
		}
		
		//START THE SHOW
		advance();
	}

  }  //END CLASS
} //END PACKAGE