//  GAME CODE 
//  RELEASE CANDIDATE 1.03

//  FIX ELEMENT DRAWING PROBLEMS

// ----------------
// DIRECT EXECUTION
// ----------------


	//BROWSER DETECT
	bro = "other";
	if(navigator.userAgent.indexOf("Safari") > -1) bro = "Safari";
	if(navigator.userAgent.indexOf("Firefox") > -1) bro = "Firefox";
	if(navigator.userAgent.indexOf("Chrome") > -1) bro = "Chrome";
	if(bro != "Safari" && bro != "Firefox") location = "flash/level_0.html";
	
	//SET FONT SPECIFICATION
	theFontSize = 32 - theLevel*2;
	
	//SET NUMBER OF SCAN LINES
	numScanLines = theLevel + 1;
	
	//DECLARE VARIABLES
	numLevels = 8  //SEVEN MAIN LEVELS PLUS BONUS
	gameState = "starting";
	Xmax = 750;
	Ymax = 550;
	mousePos = 0;
	paddleSpeed = 0;
	paddleWas = 0;
	paddleIs = 0;
	lastRand = 0;
	thisRand = 0;
	rsvpRun = true;
	scanSpeedArray = new Array(numScanLines);
	
	//CREATE ARRAYS FOR X AND Y SPEED
	XspeedArray = new Array(numTargets);
	YspeedArray = new Array(numTargets);
	
	//CREATE ARRAYS TO STORE POSITION VALUES AND SPEEDS
	XposArray = new Array(numTargets);
	YposArray = new Array(numTargets);
	XdirArray = new Array(numTargets);
	YdirArray = new Array(numTargets);
	
	//CREATE ARRAY FOR RANDOM NUMBER COMPARISONS
	//ALLOWS FRESHRAND TO WORK WITH MULTIPLE CALLING FUNCTIONS
	//0 FOR DEFAULT WORD
	//1 FOR RSVP TEXT
	//2 FOR BINARY COIN FLIP (UP/DOWN DIRECTIONS)
	randStore = new Array(0,0,0);
	
	//SPAWN RSVP METERING DIV
	ne = document.createElement("div");
	ne.id = "rsvpMeter";
	ne.setAttribute("style","position: absolute; font:" + theFontSize + "pt Arial; visibility: hidden;");
	document.getElementById("main").appendChild(ne);
	
	//SPAWN SCANLINE ELEMENTS
	for(i=0; i<numScanLines; i++)
	{
		ne = document.createElement("div");
		ne.id = "scanLine_"+i;
		ne.setAttribute("style","position: absolute; top: 0px; width: 750px; height: 1px; background-color: #00FF00; opacity: 0.2; filter: alpha(opacity = 0.2); visibility: hidden;");
		document.getElementById("main").appendChild(ne);			
	}
	
	//CENTER SCREEN ELEMENTS - MUST BE CALLED BEFORE INITIALIZING TARGETS BUT AFTER SCANLINES ARE SPAWNED
	centerUp();
	window.addEventListener("resize", centerUp, true);
	
	//DEFINE DEFAULTWORDS ARRAY FOR RSVP TARGETS WHILE IN LOAD STATE
	defaultWords = new Array("so","play","work","and","go","run","start","now","one","zero");
	
	//DEFINE SCREEN BOTTOM FOR PADDLE ANIMATIONS
	botNum = topOffset + Ymax;
	
	//COMPUTE LONG-WORD BUFFERS FOR RSVP FUNCTION
	//PREVENTS RSVP ITEMS FROM OVERRUNNING RIGHT EDGE
	allRSVPBuffers = new Array(10);
	
	for(i=0; i<10; i++)
	{
		checkArray = allRSVPTexts[i].split(" ");
		//FIND LONGEST WORD
		longIndex = 0;
		for(j=0; j<checkArray.length; j++)
		{
			if(checkArray[j].length > checkArray[longIndex].length) longIndex = j;	
		}
		
		//COMPUTE RSVP NO-DISPLAY BUFFER BY ASSIGNING LONGEST WORD TO INVISIBLE ELEMENT
		document.getElementById("rsvpMeter").innerHTML = checkArray[longIndex];
		allRSVPBuffers[i] = document.getElementById("rsvpMeter").offsetWidth;			
	}
	
	//CREATE LISTENER FOR PADDLE ANIMATION
	window.addEventListener("mousemove", register, true);
	
	//SET UP SCANLINE SPEEDS
	for(i=0; i<numScanLines; i++)
	{
		scanSpeedArray[i] = 1 + Math.floor(Math.random()*5);	
	}
	
	//SET CURRENT COLOR OF PLAYFIELD FOR FIELD STROBE EFFECT
	fieldColor = "black";
		

//  --------------
//  CUSTOM METHODS
//  --------------

	
	//THIS METHOD CONSOLIDATES VARIOUS METHODS USED TO SPAWN TARGETS
	function targetSpawn(wt)
	{
		//PAGE ELEMENT
		ne = document.createElement("div");
		ne.id = "target_"+wt;
		ne.setAttribute("style","position: absolute; font:" + theFontSize + "pt Arial; color: #00FF00;");
		document.getElementById("main").appendChild(ne);
		//DATA OBJECT
		window["targObj_"+wt] = new Object();
		window["targObj_"+wt].rsvpTextArray = new Array();
		window["targObj_"+wt].currRSVPBuffer = 0;
		window["targObj_"+wt].rsvpCount = 0;
		initTarget(wt);  //SET INITIAL POSITION
		wallBounce(wt);  //SET INITIAL SLOPE ASSIGNMENT			
	}


	// **** RSVP METHODS ****
	
	// SELECT TEXT FOR RSVP
	// BRACKET NOTATION ALLOWS INDEPENDENT OPERATION OF MULTIPLE TARGETS
	function getRSVP(whichTarget)
	{
		
		//GET ITEM NUMBER FOR ARRAY SELECTION, USING GENERAL RANDOM-NUMBER UTILITY
		//RSVP IS CLIENT '1'
		r = freshRand(10,1);
		
		//SELECT AND SPLIT INTO ARRAY OF WORDS
		window["targObj_" + whichTarget].rsvpTextArray = allRSVPTexts[r].split(" ");
		//RETRIEVE RIGHTHAND BUFFER VALUE
		window["targObj_" + whichTarget].currRSVPBuffer = allRSVPBuffers[r];
		
	}
	
	//CYCLE THROUGH RSVP TEXT -- RUNS ON INTERVAL "RSVPINT"
	// BRACKET NOTATION USED HERE AS WELL
	function serialize()
	{
		//DO STROBE EFFECTS IF ENGAGED
		if(strobe != "none" && Math.random()*7 < 5) strobeEffects();	
		
		for(i=0; i<numTargets; i++)
		{
			//SPECIFY TARGET OBJECT FOR THIS PASS
			theObj = window["targObj_" + i];
			
			//NO CHANGES IF WITHIN LONG-WORD BUFFER AT RIGHT EDGE OF SCREEN
			if(XposArray[i] < leftOffset + (Xmax - theObj.currRSVPBuffer) && rsvpRun)
			{
				if(theObj.rsvpTextArray[theObj.rsvpCount] == undefined) //TEXT IS LOADING
				{
					theText = defaultWords[freshRand(10, 1)]; //SUBSTITUTE DEFAULT WORD
				}
				else  //TEXT ALL LOADED
				{
					theText = theObj.rsvpTextArray[theObj.rsvpCount];
				}
				
				//WRITE RESULTS TO SCREEN
				document.getElementById("target_"+ i).innerHTML = theText;

				//GET NEW TEXT IF WE'RE DONE WITH THIS ONE
				if(theObj.rsvpCount == theObj.rsvpTextArray.length)
				{
					getRSVP(i);
					theObj.rsvpCount = -1;
				}
				theObj.rsvpCount ++;
			}
		}
	}  // END SERIALIZE()

	
	//ANIMATE THE PADDLE
	function paddler()
	{	
		
		//MOVE PADDLE AND COMPUTE SPEED IF CURSOR IS WITHIN FRAME Y RANGE
		p = document.getElementById("playerPaddle");
		if(mousePos > (topOffset + paddleHeight/2) && mousePos < (botNum - paddleHeight))
		{
			p.style.left = leftOffset - paddleWidth/2 + "px";
			p.style.top = mousePos - paddleHeight/2 + "px";
			
			//STORE DATA FOR SPEED COMPUTATION
			paddleWas = paddleIs;
			paddleIs = mousePos - paddleHeight/2;
			
			//COMPUTE PADDLE SPEED
			paddleSpeed = paddleWas - paddleIs;
			
		}
		else
		{
			if(mousePos < topOffset) p.style.top = topOffset + "px";
			if(mousePos > botNum - paddleHeight) p.style.top = botNum - paddleHeight + "px";
		}
		
		//ANIMATE ENEMY PADDLE
		ep = document.getElementById("enemyPaddle");
		epPos = parseInt(ep.style.top);
		
		//FIRST, COMPUTE CLOSEST TARGET (THERE MAY BE SEVERAL)
		proxIndex = 0;
		for(i=0; i<numTargets; i++)  //CHECK EACH TARGET
		{
			if(XposArray[i] > XposArray[proxIndex]) proxIndex = i;
		}
		

		//TRACK NEAREST TARGET
		//KEEP ENEMY PADDLE FROM TRACKING OUT OF GAME BOX
		if(YposArray[proxIndex] < (botNum - paddleHeight))
		{
			ep.style.top = YposArray[proxIndex] + "px";
		}
		
		//UPDATE SCOREBOARD
		document.getElementById("scoreboard").innerHTML = playerScore + "|" + enemyScore;
		
		//EVALUATE SCORE FOR WIN/LOSS
		if(enemyScore == 0)  //PLAYER WINS
		{
			playerWins = true;
			gameState = "over"				
		}
		if(playerScore == 0)  //PLAYER LOSES
		{
			playerWins = false;
			gameState = "over"					
		}
		
	}
			
	//TARGET ANIMATION
	
	//SET FEATURES OF TARGETS INITIALLY AND WHEN RE-SETTING
	function initTarget(whichTarget)
	{
		//DESIGNATE THE PAGE ELEMENT IN QUESTION
		we = document.getElementById("target_" + whichTarget);
		
		//SOUND
		sounder("enemySound");
		
		//GENERATE RANDOM START POSITION ON PAGE
		//INCLUDE OFFSETS IN ARRAY-STORED VALUES
		
		//SET Y POSITION
		r =  topOffset + paddleHeight + Math.floor(Math.random()*(Ymax - paddleHeight*2));
		//ENTER THIS POSITION IN POSARRAY
		YposArray[whichTarget] = r;
		
		//SET ENEMY PADDLE ON TARGET
		document.getElementById("enemyPaddle").style.top = r + "px";
		
		//ASSIGN DEFAULT TEXT TO START
		we.innerHTML = defaultWords[freshRand(defaultWords.length, 1)];
		
		//SET X POSITION AT RIGHT BORDER
		XposArray[whichTarget] = leftOffset + Xmax - we.offsetWidth;
		
		
		//ASSIGN INITIAL POSITION TO THE ELEMENT
		we.style.top = YposArray[whichTarget] + "px";
		we.style.left = XposArray[whichTarget] + "px";
		
		//RANDOMLY CHOOSE INITIAL DIRECTIONS OF MOVEMENT
		if(freshRand(2, 2) == 0)
		{
			YdirArray[whichTarget] = "up";			
		}
		else
		{
			YdirArray[whichTarget] = "down";
		}
		
		XdirArray[whichTarget] = "left";
	}
	
	//RESET SLOPE OF TRAVEL (XSPEED, YSPEED) ON WALL COLLISION
	function wallBounce(whichTarget)
	{
		//document.getElementById("enemySound").;
		sounder("enemySound");
		XspeedArray[whichTarget] = minSpeed + Math.floor(Math.random()*bonusSpeed);
		YspeedArray[whichTarget] = minSpeed + Math.floor(Math.random()*bonusSpeed);		
	}
	
	//RESET SLOPE OF TRAVEL ON PADDLE COLLISION
	function paddleBounce(whichTarget)
	{
		XspeedArray[whichTarget] = 1 + Math.floor(Math.random()*bonusSpeed);
		YspeedArray[whichTarget] = 1 + paddleSpeed*0.6;		
	}

	
	//ANIMATE WORD ELEMENT (TARGET, OR BALL): RUN AS INTERVAL "THEGAME"
	//THIS IS THE MAIN GAME LOGIC
	function animate()
	{	
		if(gameState == "play")
		{
			
			for(i=0; i<numTargets; i++)
			{
				
				//IMPLEMENT CRAZY-IVAN STUNT IF ENGAGED
				if(crazyIvan)
				{
					if(Math.random()*300 < 1)
					{
						if(XspeedArray[i] == 0)
						{
							XspeedArray[i] = 10;
							YspeedArray[i] = 0;
							XdirArray[i] = "left";
						}
						else
						{
							XspeedArray[i] = 0;
						}
					}	
				}
				
				//Y AXIS
				if(YdirArray[i] == "up")
				{
					YposArray[i] -= YspeedArray[i];	
				}
				else //DIRECTION IS DOWN
				{
					YposArray[i] += YspeedArray[i];					
				}
				
				//X AXIS
				if(XdirArray[i] == "left")
				{
					XposArray[i] -= XspeedArray[i];	
				}
				else //DIRECTION IS RIGHT
				{
					XposArray[i] += XspeedArray[i];					
				}			
				
				//ASSIGN UPDATED POSITION
				we = document.getElementById("target_"+i);
				we.style.top = YposArray[i] + "px";
				we.style.left = XposArray[i] + "px";
				
				//BOUNDARY TESTS
				//TOP
				if(YposArray[i] < topOffset + YspeedArray[i]) 
				{
					YdirArray[i] = "down";
					wallBounce(i);
				}
				//BOTTOM
				if(YposArray[i] > (Ymax + topOffset) - we.offsetHeight - YspeedArray[i])
				{
					YdirArray[i] = "up";
					wallBounce(i);
				}
				
				//SPECIAL LEFT-SIDE TEST FOR FALSE TARGETS 
				//AFTER FIRST TWO, EVERY EVEN-NUMBERED TARGET IS FALSE (EXTRA FUN FOR BONUS LEVEL)
				//FALSE TARGETS RESET 100 PX BEFORE REACHING LEFT WALL
				if(i > 1 && i%2 == 0 && XposArray[i] < leftOffset + 100)
				{
					initTarget(i);
					wallBounce(i);
				}				
				
				//LEFT -- PADDLE COLLISION OR MISS
				if(XposArray[i] < leftOffset + XspeedArray[i])
				{
					if(paddleCollision(i))  // COLLISION: PLAYER SCORES
					{
						XdirArray[i] = "right";
						paddleBounce(i);
						sounder("backSound");
						playerScore ++;
						enemyScore --;
						
						//IN BONUS LEVEL, SPAWN AN ADDITIONAL TARGET
						if(theLevel == numLevels -1)
						{
							numTargets ++;
							targetSpawn(numTargets-1);	
						}
						
						//IF ADDSPEED IS ENABLED, ACCELERATE TARGETS
						if(addSpeed && (minSpeed < 3.5))
						{
							minSpeed *= 1.25;
						}
					}
					else  // MISS
					{
						sounder("missSound");
						playerScore --;
						enemyScore ++;
						initTarget(i);
						wallBounce(i);
					}
				}
				//RIGHT
				if(XposArray[i] > (leftOffset + Xmax) - we.offsetWidth - XspeedArray[i])
				{
					XdirArray[i] = "left";
					wallBounce(i);
				}					
					
			} //END FOR LOOP
		
		} 
		else if(gameState == "over") //GAMESTATE IS 'OVER'
		{
			//MAKE GAME ELEMENTS VISIBLE (MIGHT BE STROBED OFF)
			showTheGame();
			
			//TURN FRAME FIELD BACK TO BLACK (MAY HAVE BEEN SET TO GREEN)
			document.getElementById("frame").style.backgroundColor = "#000000";
			
			//TURN OFF ANIMATIONS
			clearInterval(theGame);
			clearInterval(rsvpInt);
			clearInterval(paddleInt);
			
			//BLANK THE TARGET ELEMENTS
			for(i=0; i<numTargets; i++)
			{
				document.getElementById("target_"+i).innerHTML = "";
			}
			
			//HIDE THE SCAN LINES
			for(i=0; i<numScanLines; i++)
			{
				document.getElementById("scanLine_"+i).style.top = 0-200 + "px";
			}
			
			//PARK THE PADDLES
			we = document.getElementById("playerPaddle");
			we.style.top = (topOffset + Ymax/2 - paddleHeight/2) + "px";
			we = document.getElementById("enemyPaddle");
			we.style.top = (topOffset + Ymax/2 - paddleHeight/2) + "px";
			
			//OUTCOME MESSAGE
			if(playerWins)
			{
				sounder("winSound");
				document.getElementById("scoreboard").innerHTML = "PASS";
			}
			else
			{
				sounder("loseSound");
				document.getElementById("scoreboard").innerHTML = "FAIL";				
			}
			
			overTime = setTimeout("overThis()",5000);
			
			//RE-CENTER SCOREBOARD
			we = document.getElementById("scoreboard");
			we.style.left = (leftOffset + Xmax/2 - we.offsetWidth/2) + "px";			
		}
		
		
		//SCANLINE EFFECT
			for(i=0; i<numScanLines; i++)
			{
				we = document.getElementById("scanLine_"+i);
				scanPos = parseInt(we.style.top);
				if(scanPos + we.offsetHeight > topOffset) we.style.visibility = "visible";
				//VARY SIZE OF SCANLINE
				we.style.height = 1 + Math.floor(Math.random()*8) + "px";
				//MOVE DOWN-SCREEN
				scanPos += scanSpeedArray[i];
				we.style.top = scanPos + "px";
				if(scanPos > topOffset + Ymax + we.offsetHeight)
				{
					we.style.top = (0 - 100 - Math.floor(Math.random()*50)) + "px";
					we.style.visibility = "hidden";
					scanSpeedArray[i] = 1 + Math.floor(Math.random()*5);	
				}
			}
	
	} //END ANIMATE() FUNCTION
	
	//LEVEL-OVER TRANSITION HANDLER
	function overThis()
	{
		if(playerWins)
		{
			if(theLevel == numLevels - 1)  //REWARD FOR BONUS LEVEL
			{
				location = "ifftwn.htm";
			}
			else
			{
				switch(theLevel)  //ADVANCE TO NEXT REGULAR-LEVEL TEXT
				{
					case 0:
						levelName = "abergorlech";
						break;						
					case 1:
						levelName = "bronwydd";
						break;						
					case 2:
						levelName = "cefneithin";
						break;						
					case 3:
						levelName = "dryslwin";
						break;					
					case 4:
						levelName = "fflint";
						break;						
					case 5:
						levelName = "gwynedd";
						break;						
					case 6:
						levelName = "hirwaun";
						break;
							
				}
				location = levelName + ".htm";	
			}		
		}
		else
		{
			location = "level_" + theLevel + ".htm";			
		}	
	}

	//COLLISION DETECTION FOR PADDLE	
	function paddleCollision(whichElement)
	{
		paddlePos = parseInt(document.getElementById("playerPaddle").style.top);
		targetPos = YposArray[whichElement] + document.getElementById("target_"+whichElement).offsetHeight/2;
		
		if( targetPos > paddlePos && targetPos < paddlePos + paddleHeight)
		{
			return true;
		}
		else
		{
			return false;	
		}
	}
	
	//STROBE EFFECTS, OR VISUAL PRANKS: 
	//'FIELD" TURNS THE PLAY AREA GREEN, HIDING TARGETS; 'PADDLES' HIDES THE PADDLES;
	//'GAME' MAKES WHOLE GAME INVISIBLE
	//ALL EFFECTS RECUR RANDOMLY, DRIVEN BY A RANDOMIZER WITHIN THE RSVP LOOP
	
	function strobeEffects()
	{
		switch(strobe)
		{
			case "field":
				if(fieldColor == "black")
				{
					fieldColor = "green";
					document.getElementById("frame").style.backgroundColor = "#00FF00";
				}
				else
				{
					fieldColor = "black";
					document.getElementById("frame").style.backgroundColor = "#000000";			
				}
				break;
					
		case "paddles":
				if(document.getElementById("playerPaddle").style.visibility == "visible")
				{
					document.getElementById("playerPaddle").style.visibility = "hidden";
					document.getElementById("enemyPaddle").style.visibility = "hidden";
				}
				else
				{
					document.getElementById("playerPaddle").style.visibility = "visible";
					document.getElementById("enemyPaddle").style.visibility = "visible";			
				}
				break;
				
		case "game":
				if(document.getElementById("playerPaddle").style.visibility == "visible")
				{
					hideTheGame();
				}
				else
				{
					showTheGame();
				}
				break;

		}	
	}
	
	function showTheGame()
	{
		document.getElementById("frame").style.visibility = "visible";
		document.getElementById("scoreboard").style.visibility = "visible";
		document.getElementById("playerPaddle").style.visibility = "visible";
		document.getElementById("enemyPaddle").style.visibility = "visible";
		for(i=0; i<numTargets; i++)
		{
			document.getElementById("target_"+i).style.visibility = "visible";	
		}		
	}
	
	function hideTheGame()
	{
		document.getElementById("frame").style.visibility = "hidden";
		document.getElementById("scoreboard").style.visibility = "hidden";
		document.getElementById("playerPaddle").style.visibility = "hidden";
		document.getElementById("enemyPaddle").style.visibility = "hidden";
		for(i=0; i<numTargets; i++)
		{
			document.getElementById("target_"+i).style.visibility = "hidden";	
		}		
	}
	
	// CENTER PAGE ELEMENTS
	function centerUp()
	{
		leftOffset = (innerWidth - Xmax)/2;
		topOffset = (innerHeight - Ymax)/2;
		
		//N.B. 'COVER' ELEMENT OBSCURES OTHERS UNTIL FIRST CENTERING IS COMPLETE
		we = document.getElementById("cover");
		we.style.top = topOffset + "px";
		we.style.left = leftOffset + "px";		
		
		//FRAME
		we = document.getElementById("frame");
		we.style.top = topOffset + "px";
		we.style.left = leftOffset + "px";
		
		//SCOREBOARD
		we = document.getElementById("scoreboard");
		we.innerHTML = playerScore + "|" + enemyScore;
		we.style.top = (topOffset + Ymax/2 - we.offsetHeight/2) + "px";
		we.style.left = (leftOffset + Xmax/2 - we.offsetWidth/2) + "px";
		
		//SCANLINES
		for(i=0; i<numScanLines; i++)
		{
			we = document.getElementById("scanLine_"+i);
			we.style.top = (topOffset - we.offsetHeight) + "px" ;
			we.style.left = leftOffset + "px";
		}
		
		//CONFIGURE PLAYER PADDLE
		p = document.getElementById("playerPaddle");
		p.style.width = paddleWidth + "px";
		p.style.height = paddleHeight + "px";
		p.style.left = (leftOffset + (paddleWidth/2) * -1) + "px";
		p.style.top = topOffset + "px";
		
		//CONFIGURE ENEMY PADDLE
		p = document.getElementById("enemyPaddle");
		p.style.width = paddleWidth + "px";
		p.style.height = paddleHeight + "px";
		p.style.left = (leftOffset + Xmax) + "px";
		p.style.top = topOffset + "px";
		
		//DELAY VISIBILITY IN ORDER TO DEFEAT SCREEN-DRAW LAG
		//THIS ONLY APPLIES ON INITIAL PAGE LOAD
		if(gameState == "starting") setTimeout("showTime()", 500);
		
	}
	
	function showTime()
	{
		
		//MAKE ALL GAME ELEMENTS VISIBLE
		document.getElementById("frame").style.visibility = "visible";
		document.getElementById("scoreboard").style.visibility = "visible";
		document.getElementById("playerPaddle").style.visibility = "visible";
		document.getElementById("enemyPaddle").style.visibility = "visible";
		//HIDE THE COVER
		document.getElementById("cover").style.visibility = "hidden";
		
		//SET GAMESTATE
		gameState = "play";
		
		//SPAWN TARGET ELEMENTS
		for(i=0; i<numTargets; i++)
		{
			targetSpawn(i);		
		}
			
		//START THE SHOW: COMMENCE SETINTERVAL LOOPS
		for(i=0; i<numTargets; i++)
		{
			getRSVP(i);
		}
		theGame = setInterval("animate()", 10);
		rsvpInt = setInterval("serialize()", 350);
		paddleInt = setInterval("paddler()",5);	
		}
	
	//CAPTURE CURRENT MOUSE Y COORD
	function register(evt)
	{
		mousePos = evt.pageY;	
	}
	
	//TWO-PASS UNIQUE RANDOM NUMBER GENERATOR
	//MODIFIED TO SUPPORT CALLS FROM MULTIPLE FUNCTIONS
	function freshRand(range, client)
	{
		lastRand = randStore[client];
		
		while(thisRand == lastRand)
		{
			thisRand = Math.floor(Math.random()*range);	
		}
		randStore[client] = thisRand;
		return thisRand;	
	}
	
	//SOUND HANDLER
	function sounder(whichSound)
	{
		if(bro == "Firefox") prefix = "f_";
		if(bro == "Safari" || bro == "Chrome") prefix = "s_";
		document.getElementById(prefix + whichSound).play();		
	}
	
	//FOR TEST PURPOSES
	function testify(wha)
	{
		document.getElementById("test").innerHTML = wha;	
	}