//TEXT CODE SCRIPT, RELEASE CANDIDATE 1.02

// FIX CENTERING; AND AUDIO PROBLEMS IN FIRST TWO NODES

// NOTE:
// IN XML TEXT SOURCEFILES, $ BEGINS ITALICS, % FINISHES, ~ INDICATES <BR>, ^ IS ACUTE ACCENT
// ] IS ALIAS FOR SECRET LINK

//
// DIRECT EXECUTION
//

//DECLARE NUMBER OF LEVELS - CONSTANT: 7 LEVELS PLUS BONUS
numLevels = 8;

//DECLARE NUMBER OF TRANSIENT SOUNDS FOR TEXT STREAMING PHASE
numTextSounds = 100;

//DECLARE NUMBER OF TRANSIENT SOUNDS FOR TEXT DEFORM PHASE
numDeformSounds = 20;

//SET THE STARTING NODE - CONSTANT
currNode = 0;

//SET INITIAL STATE: VALUES ARE 'STARTING' 'STREAMING', 'PAUSING', 'DEFORMING'
theState = "starting";

//FOR FANCY ITALICS HANDLING (CURSE YOU, INNERHTML!)
bufferIt = false;
emphBuffer = "";

//SCREEN DIMENSIONS
Xmax = 750;
Ymax = 550;

//REVERSE LOCK (NO REVERSE FROM LEVEL-UP SCREEN)
reverseLock = false;

//BYPASS FOR DEFAULT ENDGAME TRANSITION IF PLAYER FINDS BONUS LINK
gotBonus = false;

//SET SOUND FORMAT ACCORDING TO BROWSER TYPE
bro = "other";
if(navigator.userAgent.indexOf("Safari") > -1) bro = "Safari";
if(navigator.userAgent.indexOf("Firefox") > -1) bro = "Firefox";
if(navigator.userAgent.indexOf("Chrome") > -1) bro = "Chrome";
if(bro == "Firefox") format = "ogg";
if(bro == "Safari" || bro == "Chrome") format = "mp3";


centerUp();
window.addEventListener("resize", centerUp, true);

window.addEventListener("click", clicker, true);

//START BACKGROUND SOUND (HUM)
document.getElementById("bgSound").src = "sounds/" + format + "/text/hum." + format;
document.getElementById("bgSound").volume = 0;
document.getElementById("bgSound").play();

//ADD DELAY TO COVER LOADING OF BG SOUND
soundDelayTime = setTimeout("soundsReady()", 500);


// --------------
// CUSTOM METHODS
// --------------

function soundsReady()  //LOAD TEXTS AND START THE SHOW
{
	//LOAD LEVEL TEXTS
	loadXML("texts/level_" + theLevel + ".xml");	
}


function clicker(evt)
{
	//ALLOW FOR CLICK WHILE TEXT IS STREAMING IN
	inProgress = false;
	
	//STOP STREAMING OR DEFORM IF NECESSARY; MARK AS IN-PROGRESS OR NOT
	
	if(theState == "streaming") // TEXT STREAMING IN; STOP STREAMING AND MARK AS IN-PROGRESS
	{
		clearInterval(streamInt);
		inProgress = true;
	}
	
	if(theState == "pausing")
	{
		clearTimeout(pauseTime);	
	}
	
	if(theState == "deforming")  // IN DEFORM PHASE; STOP DEFORM PROCESS AND MARK NOT IN-PROGRESS
	{
		clearInterval(deformInt);
		inProgress = false;	
	}
	
	if(evt.pageX >= innerWidth/2)  //CLICK WAS ON THE RIGHT: ADVANCE
	{
		advance();	
	}
	else  // CLICK WAS ON THE LEFT: REVERSE
	{
		if(reverseLock == false)
		{
			if(inProgress && currNode > 1)  // STEP BACK TWO IF CLICK WAS IN-PROGRESS 
			{
				currNode -=2;
			}
			else if(currNode > 0)  // STEP BACK ONE IF NOT IN-PROGRESS
			{
				currNode --;	
			}
			advance();
		}	
	}			
}

function advance()  //MOVE TO NEXT NODE
{
	
	clearStates();
	theState = "streaming";
	
	//PLAY BEEP
	sounder("beep");
	
	//TYPING SOUND FOR INITIAL (TITLE) NODE
	if(currNode == 0)
	{
		sounder("typing");
	}
	
	//ACTIVATE BG SOUND (HUM) IF NOT ON LEVEL-UP SCREEN
	if(currNode < numNodes)
	{
		document.getElementById("bgSound").src = "sounds/" + format + "/text/hum." + format;
		document.getElementById("bgSound").volume = 1;
		document.getElementById("bgSound").play();
	}
	
	//BLANK TEXT DISPLAY
	document.getElementById("readout").innerHTML = "";
	
	//HAVE WE SEEN ALL NODES?  IF SO, NEXT GAME LEVEL UNLESS AT END
	if(currNode == numNodes)
	{
		//TRIPLE BEEP
		sounder("tripleBeep");
		
		//INCREMENT LEVEL
		theLevel ++;
		
		//LOCK REVERSE FUNCTION
		reverseLock = true;
		
		//DISPLAY "LEVEL UP" OR "GAME OVER" MESSAGE
		ne = document.createElement("div");
		ne.setAttribute("style","position: absolute; font: 60pt Courier New, Courier, monospace; color: #00FF00;");

		if(theLevel < numLevels -1) //ALLOW FOR BONUS LEVEL
		{
			ne.innerHTML = "LEVEL UP";
		}
		else if(theLevel == numLevels - 1)
		{
			document.getElementById("transSound").volume = 1;
			sounder("youWin");
			ne.innerHTML = "GAVE MORE";		
		}
		
		document.getElementById("readout").appendChild(ne);
		ne.style.top = Ymax/2 - ne.offsetHeight/2;
		ne.style.left = Xmax/2 - ne.offsetWidth/2;
		
		//SET TIMEOUT TO TRANSITION
		overTime = setTimeout("overThis()",7000);			
	}
	else
	{
		theText = xmlDoc.getElementsByTagName("node")[currNode].childNodes[0].nodeValue;
		charCount = 0;
		streamInt = setInterval("textUp()", 35);
		currNode ++;
	}	
	
}

function overThis()
{
	if(gotBonus == false)
	{
		if(theLevel < numLevels-1)
		{
			location = "level_" + theLevel + ".htm";			
		}
		else  //END OF THE SHOW
		{
			location = "index.htm";  //BACK TO START PAGE			
		}
	}	
}

function clearStates()
{
	if(theState == "streaming") clearInterval(streamInt);
	if(theState == "deforming") clearInterval(deformInt);
	if(theState == "pausing") clearTimeout(pauseTime);
}

function sounder(whichSound)
{
	document.getElementById("transSound").volume = 0.25;
	document.getElementById("transSound").src = "sounds/" + format + "/text/" + whichSound + "." + format;
	document.getElementById("transSound").play();	
}

function specialSounder(whichSound)
{
	document.getElementById("specialSound").src = "sounds/" + format + "/text/" + whichSound + "." + format;
	document.getElementById("specialSound").play();	
}

function textUp()
{
	
	//KEEP THE BG HUM CYCLING CONSTANTLY
	if(document.getElementById("bgSound").currentTime > 15) document.getElementById("bgSound").currentTime = 0;
	
	theChar = theText.charAt(charCount);
	
	//CHARACTER ENTRY SOUND EFFECTS

	if(currNode > 1 && Math.floor(Math.random()*75) == 1)  //TRANSIENT SOUND FOR REGULAR TEXT NODES
	{
		sounder("textSound_"+Math.floor(Math.random()*numTextSounds));
	}
	
	switch(theChar)  //HANDLE SPECIAL CHARACTERS
	{
		
		case "@":
			document.getElementById("readout").innerHTML += "&nbsp;";
			break;
		
		case "~":
			document.getElementById("readout").innerHTML += "<br>";
			break;
			
		case "^":
			emphBuffer += "&eacute;"
			break;

		case "$":
			emphBuffer = "";
			bufferIt = true;
			break;
	
			case "%":
			document.getElementById("readout").innerHTML += "<em>"+emphBuffer+"</em>";
			bufferIt = false;
			break;
			
		case "]":
			document.getElementById("readout").innerHTML += "<span onClick='goBonus()'>secrets</span>";
			break;
			
		case "{":
			emphBuffer = "";
			bufferIt = true;
			break;
			
		case "}":
			bufferIt = false;
			switch(emphBuffer)
			{
				case "0":
					specialSounder("thunderclap");
					break;
				case "1":
					specialSounder("rimshot");
					break;
				case "2":
					specialSounder("megavore");
					break;
				case "3":
					specialSounder("textSound_30");
					break;		
			}
			break;
			
		default:
			if(bufferIt)
			{
				emphBuffer += theChar;
			}
			else
			{
				document.getElementById("readout").innerHTML += theChar;
			}
			break;
	}
	
	//INCREMENT CHARACTER COUNT
	charCount ++;
	
	//PROGRESSIVE MUTING FOR BG SOUND: EXCLUDES TITLE NODES
	theVol = 1;
	if(theText.length > 140)
	{
		charsLeft = theText.length - charCount
			if(charsLeft < 141 && charsLeft > 120)
			{
				theVol = 0.875;
			}	
			if(charsLeft < 121 && charsLeft > 100)
			{	
				theVol = 0.75;
			}	
			if(charsLeft < 101 && charsLeft > 80)
			{
				theVol = 0.625;
			}	
			if(charsLeft < 81 && charsLeft > 60)
			{	
				theVol = 0.5;
			}	
			if(charsLeft < 61 && charsLeft > 40)
			{
				theVol = 0.375;
			}	
			if(charsLeft < 41 && charsLeft > 20)
			{
				theVol = 0.25;
			}	
			if(charsLeft < 21)
			{
				theVol = 0.125;
			}		
		document.getElementById("bgSound").volume = theVol;		
	}
	
	if(charCount == theText.length) //LAST CHARACTER HAS STREAMED IN
	{
	
		//SIGNAL END OF TEXT STREAM
		sounder("endBeep");
		//PUT BG SOUND ON PAUSE SO IT CAN BE REPLAYED ON NEXT NODE
		document.getElementById("bgSound").volume = 0;	
			
		clearStates();
		theState = "pausing";
		//CALCULATE WAIT TIME BEFORE DEFORMATION: 10 SECS + FACTOR BASED ON TEXT LENGTH
		waitSpan = 10000 + (document.getElementById("readout").innerHTML.length * 3);
		pauseTime = setTimeout("waitABeat()", waitSpan);

	}
	
}  // END OF TEXTUP() METHOD

function waitABeat()
{
	clearStates();
	theState = "deforming";
	
	//SCAN TEXT TO DESIGNATE NO-DEFORM SPANS
	noDeform = new Array();
	ruleOut = false;
	theText = document.getElementById("readout").innerHTML;
	
	for(i=0; i<theText.length; i++)
	{
		switch(theText.charAt(i))
		{
			
			case "<":
				ruleOut = true;
				noDeform.push(i);
				break;
				
			case "&":
				ruleOut = true;
				noDeform.push(i);
				break;

			case ">":
				ruleOut = false;
				noDeform.push(i);
				break;

			case ";":
				ruleOut = false;
				noDeform.push(i);
				break;
				
			case " ":
				noDeform.push(i);
				
			default:
				if(ruleOut) noDeform.push(i);
				break;
			
		}	

	}
	
	//START DEFORMATION AS INTERVAL
	deformInt = setInterval("textDeform()", 250);	
}

//DEFORMATION FUNCTION
function textDeform()
{
	
	//SOUND EFFECTS
	if(Math.random()*5 < 1)
	{
		sounder("ds_"+Math.floor(Math.random()*numDeformSounds));
	}
	
	currText = document.getElementById("readout").innerHTML;
	
	//CAN'T INCLUDE LAST CHARACTER BECAUSE OF STRING-SPLITTING TECHNIQUE
	rand = Math.floor(Math.random()*currText.length-1);
	
	safe = true;
	
	//CHECK FOR NO-DEFORM SPANS
	for(i=0; i<noDeform.length; i++)
	{
		if(noDeform[i] == rand) safe = false;	
	}
	
	//CHECK IF ALPHANUMERAL
	q = currText.charCodeAt(rand);
	alphanumeral = false;
	if((q > 47 && q < 58) || (q > 64 && q < 91) || (q> 96 && q < 123)) alphanumeral = true;
	
	//REPLACE IF OKAY
	if(safe && alphanumeral)
	{
		
		//GENERATE REPLACEMENT CHARACTER
		switch(Math.floor(Math.random()*3))
		{
			case 0:
				antiChar = Math.floor(Math.random()*10);
				break;
				
			case 1:
				antiChar = String.fromCharCode(97 + Math.floor(Math.random()*26));
				break;
				
			case 2:
				antiChar = Math.floor(Math.random()*2);
				break;
		}
		
		upString = currText.substring(0, rand);
		downString = currText.substring(rand+1, currText.length);
		currText = upString + antiChar + downString;	
	}
	
	document.getElementById("readout").innerHTML = currText;
		
}

	
function centerUp()
{
	leftOffset = (innerWidth - Xmax)/2;
	topOffset = (innerHeight - Ymax)/2;
	
	we = document.getElementById("frame");
	we.style.top = topOffset + "px";
	we.style.left = leftOffset + "px";
	we.style.visibility = "visible";
	
	we = document.getElementById("readout");
	we.style.top = topOffset + "px";
	we.style.left = leftOffset + "px";
	we.style.visibility = "visible";
}

function goBonus()
{
	clearStates();
	gotBonus = true;
	document.getElementById("readout").style.textAlign = "center";
	document.getElementById("readout").innerHTML = "";
	for(i=0; i<16; i++)
	{
		document.getElementById("readout").innerHTML += "BONUS LEVEL ENGAGED!<br>"
	}
	
	sounder("bonusLevelEngaged");
	
	bonusTime = setTimeout("location = 'level_7.htm'", 7000);	
}

function testify(wha)
{
	document.getElementById("test").innerHTML = wha;	
}

function loadXML(theFile)
{
	var req = new XMLHttpRequest();
	req.open('GET', theFile, true);
	req.onreadystatechange = function(aEvt) 
	{
		if (req.readyState == 4) 
		{
			if(req.status == 200 || req.status == 0)
			{
				xmlDoc =  req.responseXML;
				nodes = xmlDoc.getElementsByTagName('node');
				numNodes = nodes.length;
				//CALL UP FIRST NODE TEXT
				advance();
			}
		}
	};
req.send(null);		
}